%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%本程序实现了擦洗臂运动学正解
%方法采用Godage团队运动学模型，该程序进行复现
%得到了擦洗臂空间可达工作点，
%得到的MHtM进行泰勒展开以消除模型初始长度存在奇异值问题，为后续动力学分析做铺垫。
%单位：米，秒
clc;
clear;
close all;
syms  L m x real;
syms l1 l2 l3 l4 real;
syms l5 l6 l7 l8 real;
% syms d k real;
% syms dl1 dl2 dl3 dl4 k real;
% L=0.15;   %气动肌肉最小长度
d=0.06;   %间隔盘长度
lim=0.06;   %两间隔盘距离
lmax=0.3625;   %气动肌肉最大长度
k=1;
g=9.80665;
X_dir=zeros(501,1);
Y_dir=zeros(501,1);
Z_dir=zeros(501,1);
%%%%%%%%%%%%%%%%%%%%%%
% for l1=0.3125:0.01:0.3625
%     for l2=0.3125:0.01:0.3625
%         for l3=0.3125:0.01:0.3625
%             for l4=0.3125:0.01:0.3625
%                 for l5=0.3125:0.01:0.3625
%                     for l6=0.3125:0.01:0.3625
%                         for l7=0.3125:0.01:0.3625
%                             for l8=0.3125:0.01:0.3625
%%%%%%%%%%%%%%%%%%%%%%
% l1=0.15; 
% l2=0.15; 
% l3=0.2; 
% l4=0.2;
% l5=0.2; 
% l6=0.2; 
% l7=0.2;
% l8=0.2;
% i=1;
% tt=[0:0.01:5]';
% for t=0:1:5
% l1=0.2150-sin(pi*t/25)*0.05;
% l2=0.2150-sin(pi*t/25)*0.05;
% l3=0.2150-sin(pi*t/50)*0.05;
% l4=0.2150-sin(pi*t/50)*0.05;
% l5=0.2150-sin(pi*t/25)*0.05;
% l6=0.2150-sin(pi*t/25)*0.05;
% l7=0.2150-sin(pi*t/50)*0.05;
% l8=0.2150-sin(pi*t/50)*0.05;
m1=(l1-3*l2+l3+l4)*sqrt((l1-l3)^2+(l2-l4)^2);
m2=d*(l1+l2+l3+l4)*(l4-l2);
K=m1/m2;        %曲率
R=m2/m1;        %曲率半径
if l4~=l2
m3=(l4-l2)/(l3-l1);
fai=atan(m3);               %偏转角
theta=m1/(4*d*(l4-l2));      %弯曲角度
% m5=m2/(2*m3);
% S=m5*asin(m3/(2*d));
%lamada:曲率半径，fai：偏转角，k*theta：弯曲角度。
% lamada=(3*L+l1+l2+l3)*r/(2*p);
% fai=2*p/(3*r);
% k*theta=atan(sqrt(3)*(l3-l2)/(l2+l3-2*l1));
% k*theta=K*(l1+l2+l3+l4)/4;
% d3=(l1+l2+l3+l4)/4;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m11=cos(fai)*cos(fai)*cos(k*theta)+sin(fai)*sin(fai);
m12=sin(fai)*cos(fai)*(cos(k*theta)-1);
m13=cos(fai)*sin(k*theta);
m14=R*cos(fai)*(1-cos(k*theta));
m21=m12;
m22=sin(fai)*sin(fai)*cos(k*theta)+cos(fai)*cos(fai);
m23=sin(fai)*sin(k*theta);
m24=R*sin(fai)*(1-cos(k*theta));
m31=-m13;
m32=-m23;
m33=cos(k*theta);
m34=R*sin(k*theta);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Z=[M11 M12 M13;M21 M22 M23;M31 M32 M33];        %Z旋转矩阵
% ZZ=Z*Z.';
% U1=ZZ(2,3)-ZZ(3,2);%%%%判断对称，一定要加·
% U2=Z(2,3)+Z(3,2);%%%%判断对称，一定要加·
T1=[m11 m12 m13 m14;m21 m22 m23 m24;m31 m32 m33 m34;0 0 0 1]          %总的齐次变换矩阵
%第一层
alfa=pi/2-theta/2;
P1=lim*cos(alfa)*cos(fai)+m14;
P2=lim*cos(alfa)*sin(fai)+m24;
P3=lim*sin(alfa)+m34;
T2=[m11 m12 m13 P1;
    m21 m22 m23 P2;
    m31 m32 m33 P3;
    0 0 0 1]
% %中间层
else
T2=[1 0 0 0;0 1 0 0;0 0 1 l2+lim;0 0 0 1] 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m4=(l5-3*l6+l7+l8)*sqrt((l5-l7)^2+(l6-l8)^2);
m5=d*(l5+l6+l7+l8)*(l8-l6);
K=m4/m5;        %曲率
R=m5/m4;        %曲率半径
if l8~=l6
m6=(l8-l6)/(l7-l5);
fai=atan(m6);               %偏转角
theta=m4/(4*d*(l8-l6));      %弯曲角度
n1=(l5-3*l6+l7+l8)*sqrt((l5-l7)^2+(l6-l8)^2);
n2=d*(l5+l6+l7+l8)*(l8-l6);
K1=n1/n2;        %曲率
R1=n2/n1;        %曲率半径
n3=(l8-l6)/(l7-l5);
fai1=atan(n3);               %偏转角
theta1=n1/(4*d*(l8-l6));      %弯曲角度

N11=cos(fai1)*cos(fai1)*cos(k*theta1)+sin(fai1)*sin(fai1);
N12=sin(fai1)*cos(fai1)*(cos(k*theta1)-1);
N13=cos(fai1)*sin(k*theta);
N14=R1*cos(fai1)*(1-cos(k*theta1));
N21=N12;
N22=sin(fai1)*sin(fai1)*cos(k*theta1)+cos(fai1)*cos(fai1);
N23=sin(fai1)*sin(k*theta1);
N24=R1*sin(fai1)*(1-cos(k*theta1));
N31=-N13;
N32=-N23;
N33=cos(k*theta1);
N34=R1*sin(k*theta1);
T3=[N11 N12 N13 N14;
    N21 N22 N23 N24;
    N31 N32 N33 N34;
    0 0 0 1]
% %第二层
else 
    T3=[1 0 0 0;0 1 0 0;0 0 1 l6;0 0 0 1] 
    N14=0;
    N24=0;
    N34=l6;
end    
%%%%%%%HTM%%%%%%%%%%%%%%%%%
% T=T2*T3
T=T2*T3
% X_dir(i)=T1(1,4);
% Y_dir(i)=T1(2,4);
% Z_dir(i)=T1(3,3);
% i=i+1;
% end
% scatter3(N14,N24,N34)
% hold on
%                             end
%                         end
%                     end
%                 end
%             end
%         end
%     end
% end
