%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%本程序实现了未知模型非一致轨迹一阶迭代学习自适应滑模控制。
%所选被控对象为刚柔耦合擦洗机器人，擦洗机器人由二自由度SCALA臂和两段四并联柔性机械臂组成。
%本程序基于ANSYS/ADAMS/MATLAB软件进行三联合仿真。
%迭代学习学习系统的状态信息。
%自适应滑模控制律实现对干扰的补偿
%自适应控制抑制输出力矩产生的抖振。
%增加了初始轨迹修正，使得重构后的轨迹初值与状态初值相等。
%%调参小技巧：控制变量法，参数一个一个调，先调gama，
%增大滑模面系数c可以使实际轨迹1s后快速跟踪期望曲线，但引起系统抖振，容易发散。(时间域)
%增大迭代学习步长可以加快收敛速度（迭代域）
%增大增益自适应参数gama可以更好补偿干扰，并且使曲线平滑（迭代域）。
%增大k1减小误差，但会使系统不稳定，最大滑模范数出现抖振。
%增大k2减小误差，使系统稳定，减少时间域震荡
% clc;
% clear all;
close all;

t=[0:0.001:5]';
k(1:5001)=0;%初始点
k=k';
theta=zeros(5001,210);%待迭代量的初始值
dtheta=zeros(5001,210);
%%%%%%%%%%%%%%迭代次数%%%%%%%%%%%%%%%%

M=1;
for i=0:1:M
    i;
    pause(0.01);
    theta=dtheta+theta;%反馈迭代控制方法；
%     sim('rigid_adams',[0,5]);
    sim('adams_sys_SMC',[0,5]);
    x11=x(:,1);x12=x(:,2);x13=x(:,3);x14=x(:,4);x15=x(:,5);%位置状态量
    x16=x(:,6);x17=x(:,7);x18=x(:,8);x19=x(:,9);x110=x(:,10);
    x21=x(:,11);x22=x(:,12);x23=x(:,13);x24=x(:,14);x25=x(:,15);%速度状态量
    x26=x(:,16);x27=x(:,17);x28=x(:,18);x29=x(:,19);x210=x(:,20);
    x1d1=yd(:,1);x1d2=yd(:,2);x1d3=yd(:,3);x1d4=yd(:,4);x1d5=yd(:,5);%期望位置
    x1d6=yd(:,6);x1d7=yd(:,7);x1d8=yd(:,8);x1d9=yd(:,9);x1d10=yd(:,10);
    x2d1=yd(:,11);x2d2=yd(:,12);x2d3=yd(:,13);x2d4=yd(:,14);x2d5=yd(:,15);%期望速度
    x2d6=yd(:,16);x2d7=yd(:,17);x2d8=yd(:,18);x2d9=yd(:,19);x2d10=yd(:,20);
    e11=e1(:,1);e12=e1(:,2);e13=e1(:,3);e14=e1(:,4);e15=e1(:,5);%位置误差
    e16=e1(:,6);e17=e1(:,7);e18=e1(:,8);e19=e1(:,9);e110=e1(:,10);
    e21=e2(:,1);e22=e2(:,2);e23=e2(:,3);e24=e2(:,4);e25=e2(:,5);%速度误差
    e26=e2(:,6);e27=e2(:,7);e28=e2(:,8);e29=e2(:,9);e210=e2(:,10);
    uk1=uk(:,1);uk2=uk(:,2);uk3=uk(:,3);uk4=uk(:,4);uk5=uk(:,5);%控制率
    uk6=uk(:,6);uk7=uk(:,7);uk8=uk(:,8);uk9=uk(:,9);uk10=uk(:,10);
    %%%%%%%%%%%%%%M次迭代过程中对象输出的跟踪过程%%%%%%%%%%%%%%%%
    figure(1)
    plot(t,x11,'-r',t,x1d1,'b','linewidth',2);
    grid on;
    hold on;
    figure(2)
    plot(t,x12,'-r',t,x1d2,'b','linewidth',2);
    grid on;
    hold on;
    figure(3)
    plot(t,x13,'-r',t,x1d3,'b','linewidth',2);
    grid on;
    hold on;
    figure(4)
    plot(t,x14,'-r',t,x1d4,'b','linewidth',2);
    grid on;
    hold on;
    figure(5)
    plot(t,x15,'-r',t,x1d5,'b','linewidth',2);
    grid on;
    hold on;
    figure(6)
    plot(t,x16,'-r',t,x1d6,'b','linewidth',2);
    grid on;
    hold on;
    figure(7)
    plot(t,x17,'-r',t,x1d7,'b','linewidth',2);
    grid on;
    hold on;
    figure(8)
    plot(t,x18,'-r',t,x1d8,'b','linewidth',2);
    grid on;
    hold on;
    figure(9)
    plot(t,x19,'-r',t,x1d9,'b','linewidth',2);
    grid on;
    hold on;    
    figure(10)
    plot(t,x110,'-r',t,x1d10,'b','linewidth',2);
    grid on;
    hold on;    
    figure(11)
    plot(t,e11,'--r',t,e12,':y',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,e11,'--r',t,e12,':y',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    figure(12)
    plot(t,e13,'--r',t,e14,':y',t,e15,'-m',t,e16,'--b',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,e13,'--r',t,e14,':y',t,e15,'-m',t,e16,'--b',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    figure(13)
    plot(t,e17,'--r',t,e18,':y',t,e19,'-m',t,e110,'--b',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,e17,'--r',t,e18,':y',t,e19,'-m',t,e110,'--b',t,exp(-2*t)+0.01,'g',t,-exp(-2*t)-0.01,'g','linewidth',2);
    grid on;
    %%%%%%%%迭代初值修正后的轨迹%%%%%%%%
    %%%%%%%期望位置%%%%%%
    %%%%Scala旋转关节%%%%%
    x1d=sin(pi*t/50);
    x2d=sin(pi*t/50);
    %%%上端面%%%
    x3d=0.2150-sin(pi*t/25)*0.05;
    x4d=0.2150-sin(pi*t/25)*0.05;
    x5d=0.2150-sin(pi*t/50)*0.05;
    x6d=0.2150-sin(pi*t/50)*0.05;
    %%%%下端面%%%%
    x7d=0.2150-sin(pi*t/25)*0.05;
    x8d=0.2150-sin(pi*t/25)*0.05;
    x9d=0.2150-sin(pi*t/50)*0.05;
    x10d=0.2150-sin(pi*t/50)*0.05;
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    figure(14)
    plot(t,x1d1,'-r',t,x1d,'b','linewidth',2);%红色修正后轨迹,蓝色原始轨迹
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,x1d1,'-r',t,x1d,'b','linewidth',2);
    grid on;
    figure(15)
    plot(t,x1d2,'-r',t,x2d,'b','linewidth',2);%红色修正后轨迹,蓝色原始轨迹
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,x1d2,'-r',t,x2d,'b','linewidth',2);
    grid on;
    figure(16)
    plot(t,x1d3,'-r',t,x3d,'b','linewidth',2);%红色修正后轨迹,蓝色原始轨迹
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,x1d3,'-r',t,x3d,'b','linewidth',2);
    grid on;
    figure(17)
    plot(t,x1d5,'-r',t,x5d,'b','linewidth',2);%红色修正后轨迹,蓝色原始轨迹
    grid on;
    axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
    plot(t,x1d5,'-r',t,x5d,'b','linewidth',2);
    grid on;
%     j=i+1;
%     times(j)=i;
%     ns(j)=max(nrs); 
end
%%%%%%%%%%%%%%M次迭代后位置跟踪%%%%%%%%%%%%%%%%
% figure(11)
% plot(t,x11,'-r',t,x1d1,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x11,'-r',t,x1d1,'b','g','linewidth',2);
% grid on;
% figure(12)
% plot(t,x12,'-r',t,x1d2,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x12,'-r',t,x1d2,'b','g','linewidth',2);
% grid on;
% figure(13)
% plot(t,x13,'-r',t,x1d3,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x13,'-r',t,x1d3,'b','g','linewidth',2);
% grid on;
% figure(14)
% plot(t,x14,'-r',t,x1d4,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x14,'-r',t,x1d4,'b','g','linewidth',2);
% grid on;
% figure(15)
% plot(t,x15,'-r',t,x1d5,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x15,'-r',t,x1d5,'b','g','linewidth',2);
% grid on;
% figure(16)
% plot(t,x16,'-r',t,x1d6,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x16,'-r',t,x1d6,'b','g','linewidth',2);
% grid on;
% figure(17)
% plot(t,x17,'-r',t,x1d7,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x17,'-r',t,x1d7,'b','g','linewidth',2);
% grid on;
% figure(18)
% plot(t,x18,'-r',t,x1d8,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x18,'-r',t,x1d8,'b','g','linewidth',2);
% grid on;
% figure(19)
% plot(t,x19,'-r',t,x1d9,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x19,'-r',t,x1d9,'b','g','linewidth',2);
% grid on;
% figure(20)
% plot(t,x110,'-r',t,x1d10,'b','g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,x110,'-r',t,x1d10,'b','g','linewidth',2);
% grid on;
% %%%%%%%%滑模面向量2-范数最大值随迭代次数的收敛曲线%%%%%%%%
% % figure(21)
% % plot(times,ns,'*-r')
% % grid on;
% %%%%%%角度误差
% figure(21)
% plot(t,e11,'--r',t,e12,':y',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e11,'--r',t,e12,':y',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% figure(22)
% plot(t,e13,'--r',t,e14,':y',t,e15,'-m',t,e16,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e13,'--r',t,e14,':y',t,e15,'-m',t,e16,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% figure(23)
% plot(t,e17,'--r',t,e18,':y',t,e19,'-m',t,e110,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e17,'--r',t,e18,':y',t,e19,'-m',t,e110,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% %%%%%%%角速度误差
% figure(24)
% plot(t,e21,'--r',t,e22,':y',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e21,'--r',t,e22,':y',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% figure(25)
% plot(t,e23,'--r',t,e24,':y',t,e25,'-m',t,e26,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e23,'--r',t,e24,':y',t,e25,'-m',t,e26,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% figure(26)
% plot(t,e27,'--r',t,e28,':y',t,e29,'-m',t,e210,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,e27,'--r',t,e28,':y',t,e29,'-m',t,e210,'--b',t,exp(-2*t)+0.01,'g','linewidth',2);
% grid on;
% %%%%%%%%%控制率图
% figure(27)
% plot(t,uk1,'--r',t,uk2,':y','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,uk1,'--r',t,uk2,':y','linewidth',2);
% grid on;
% figure(28)
% plot(t,uk3,'--r',t,uk4,':y',t,uk5,'-g',t,uk6,'--b','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,uk3,'--r',t,uk4,':y',t,uk5,'-g',t,uk6,'--b','linewidth',2);
% grid on;
% figure(29)
% plot(t,uk7,'--r',t,uk8,':y',t,uk9,'-g',t,uk10,'--b','linewidth',2);
% grid on;
% axes('position',[0.55,0.55,0.3,0.3]);%画小图指令
% plot(t,uk7,'--r',t,uk8,':y',t,uk9,'-g',t,uk10,'--b','linewidth',2);
% grid on;
