% Adams / MATLAB Interface - Release 2020.0.0
global ADAMS_sysdir; % used by setup_rtw_for_adams.m
global ADAMS_host; % used by start_adams_daemon.m
machine=computer;
datestr(now)
if strcmp(machine, 'GLNXA64')
   arch = 'linux64';
elseif strcmp(machine, 'PCWIN64')
   arch = 'win64';
else
   disp( '%%% Error : Platform unknown or unsupported by Adams Controls.' ) ;
   arch = 'unknown_or_unsupported';
   return
end
   [flag, topdir]=system('adams2020 -top');
if flag == 0
  temp_str=strcat(topdir, '/controls/', arch);
  addpath(temp_str)
  temp_str=strcat(topdir, '/controls/', 'matlab');
  addpath(temp_str)
  temp_str=strcat(topdir, '/controls/', 'utils');
  addpath(temp_str)
  ADAMS_sysdir = strcat(topdir, '');
else
  addpath( 'G:\adams2020\controls/win64' ) ;
  addpath( 'G:\adams2020\controls/matlab' ) ;
  addpath( 'G:\adams2020\controls/utils' ) ;
  ADAMS_sysdir = 'G:\adams2020\' ;
end
ADAMS_exec = '' ;
ADAMS_host = 'PC-20210313SWLY' ;
ADAMS_cwd ='D:\temp'  ;
ADAMS_prefix = 'Controls_Plant_2' ;
ADAMS_static = 'yes' ;
ADAMS_solver_type = 'C++' ;
ADAMS_version = '2020' ;
if exist([ADAMS_prefix,'.adm']) == 0
   disp( ' ' ) ;
   disp( '%%% Warning : missing Adams plant model file(.adm) for Co-simulation or Function Evaluation.' ) ;
   disp( '%%% If necessary, please re-export model files or copy the exported plant model files into the' ) ;
   disp( '%%% working directory.  You may disregard this warning if the Co-simulation/Function Evaluation' ) ;
   disp( '%%% is TCP/IP-based (running Adams on another machine), or if setting up MATLAB/Real-Time Workshop' ) ;
   disp( '%%% for generation of an External System Library.' ) ;
   disp( ' ' ) ;
end
ADAMS_init = '' ;
ADAMS_inputs  = 'INT_T1!INT_T2!INT_TOP_F1!INT_TOP_F2!INT_TOP_F3!INT_TOP_F4!INT_BOT_F1!INT_BOT_F2!INT_BOT_F3!INT_BOT_F4' ;
ADAMS_outputs = 'OUT_AG1!OUT_AG2!OUT_TOP_D1Y!OUT_TOP_D2Y!OUT_TOP_D3Y!OUT_TOP_D4Y!OUT_BOT_D1Y!OUT_BOT_D2Y!OUT_BOT_D3Y!OUT_BOT_D4Y!OUT_DX!OUT_DY!OUT_DZ' ;
ADAMS_pinput = 'Controls_Plant_2.ctrl_pinput' ;
ADAMS_poutput = 'Controls_Plant_2.ctrl_poutput' ;
ADAMS_uy_ids  = [
                   9
                   10
                   24
                   25
                   26
                   27
                   28
                   29
                   30
                   31
                   5
                   6
                   16
                   17
                   18
                   19
                   20
                   21
                   22
                   23
                   13
                   14
                   15
                ] ;
ADAMS_mode   = 'non-linear' ;
tmp_in  = decode( ADAMS_inputs  ) ;
tmp_out = decode( ADAMS_outputs ) ;
disp( ' ' ) ;
disp( '%%% INFO : ADAMS plant actuators names :' ) ;
disp( [int2str([1:size(tmp_in,1)]'),blanks(size(tmp_in,1))',tmp_in] ) ;
disp( '%%% INFO : ADAMS plant sensors   names :' ) ;
disp( [int2str([1:size(tmp_out,1)]'),blanks(size(tmp_out,1))',tmp_out] ) ;
disp( ' ' ) ;
clear tmp_in tmp_out ;
% Adams / MATLAB Interface - Release 2020.0.0
